/*
rnd.c - random number generator based on 16 byte seed
Version 1.0.0
Copyright (C) 2003-2004  dondalah@ripco.com (Dondalah)

This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License as
published by the Free Software Foundation; either version 2 of
the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to:

    Free Software Foundation, Inc.
    59 Temple Place - Suite 330
    Boston, MA  02111-1307, USA.
*/

/*
Usage:
       int rnd(unsigned char *rndSeed);
*/

/*
Called by:
    unsigned int rndpwr(int bits,
        unsigned char *rndSeed);
*/

/*
initialize the seed with:
       unsigned char *rndSeed;
       rndSeed = (unsigned char *) rndinit();
*/

int rnd(unsigned char *rndSeed)
   {
   int dbl[8];
   _asm push ebx
   _asm push esi
   _asm push edi
   _asm mov esi,rndSeed
   _asm lea edi,dbl
   _asm clc
   _asm mov eax,[esi]
   _asm shl eax,1
   _asm mov [edi],eax
   _asm mov eax,[esi+4]
   _asm rcl eax,1
   _asm mov [edi+4],eax
   _asm mov eax,[esi+8]
   _asm rcl eax,1
   _asm mov [edi+8],eax
   _asm mov eax,[esi+12]
   _asm rcl eax,1
   _asm mov [edi+12],eax
   _asm mov esi,rndSeed
   _asm mov edi,esi
   _asm add edi,8
   _asm clc
   _asm mov eax,[edi]
   _asm mov ebx,[esi]
   _asm add eax,ebx
   _asm mov [edi],eax
   _asm mov eax,[edi+4]
   _asm mov ebx,[esi+4]
   _asm adc eax,ebx
   _asm mov [edi+4],eax
   _asm lea esi,dbl
   _asm mov edi,rndSeed
   _asm clc
   _asm mov eax,[edi]
   _asm mov ebx,[esi]
   _asm add eax,ebx
   _asm mov [edi],eax
   _asm mov eax,[edi+4]
   _asm mov ebx,[esi+4]
   _asm adc eax,ebx
   _asm mov [edi+4],eax
   _asm mov eax,[edi+8]
   _asm mov ebx,[esi+8]
   _asm adc eax,ebx
   _asm mov [edi+8],eax
   _asm mov eax,[edi+12]
   _asm mov ebx,[esi+12]
   _asm adc eax,ebx
   _asm mov [edi+12],eax
   _asm shr eax,31
   _asm pop  edi
   _asm pop  esi
   _asm pop  ebx
   return;
   } /* rnd */
